<?php
/**
* Price increment/reduction by groups, categories and more
*
* NOTICE OF LICENSE
*
* This product is licensed for one customer to use on one installation (test stores and multishop included).
* Site developer has the right to modify this module to suit their needs, but can not redistribute the module in
* whole or in part. Any other use of this module constitues a violation of the user agreement.
*
* DISCLAIMER
*
* NO WARRANTIES OF DATA SAFETY OR MODULE SECURITY
* ARE EXPRESSED OR IMPLIED. USE THIS MODULE IN ACCORDANCE
* WITH YOUR MERCHANT AGREEMENT, KNOWING THAT VIOLATIONS OF
* PCI COMPLIANCY OR A DATA BREACH CAN COST THOUSANDS OF DOLLARS
* IN FINES AND DAMAGE A STORES REPUTATION. USE AT YOUR OWN RISK.
*
*  @author    idnovate.com <info@idnovate.com>
*  @copyright 2017 idnovate.com
*  @license   See above
*/
class Product extends ProductCore
{
    public static function priceCalculation($id_shop, $id_product, $id_product_attribute, $id_country, $id_state, $zipcode, $id_currency,
        $id_group, $quantity, $use_tax, $decimals, $only_reduc, $use_reduc, $with_ecotax, &$specific_price, $use_group_reduction,
        $id_customer = 0, $use_customer_price = true, $id_cart = 0, $real_quantity = 0)
    {
        if (!Module::isEnabled('groupinc')) {
            return parent::priceCalculation($id_shop, $id_product, $id_product_attribute, $id_country, $id_state, $zipcode, $id_currency,
            $id_group, $quantity, $use_tax, $decimals, $only_reduc, $use_reduc, $with_ecotax, $specific_price, $use_group_reduction,
            $id_customer, $use_customer_price, $id_cart, $real_quantity);
        }
        static $address = null;
        static $context = null;
        if ($address === null) {
            $address = new Address();
        }
        if ($context == null) {
            $context = Context::getContext()->cloneContext();
        }
        if ($id_shop !== null && $context->shop->id != (int)$id_shop) {
            $context->shop = new Shop((int)$id_shop);
        }
        if (!$use_customer_price) {
            $id_customer = 0;
        }
        if ($id_product_attribute === null) {
            $id_product_attribute = Product::getDefaultAttribute($id_product);
        }
        $cache_id = (int)$id_product.'-'.(int)$id_shop.'-'.(int)$id_currency.'-'.(int)$id_country.'-'.$id_state.'-'.$zipcode.'-'.(int)$id_group.
            '-'.(int)$quantity.'-'.(int)$id_product_attribute.
            '-'.(int)$with_ecotax.'-'.(int)$id_customer.'-'.(int)$use_group_reduction.'-'.(int)$id_cart.'-'.(int)$real_quantity.
            '-'.($only_reduc?'1':'0').'-'.($use_reduc?'1':'0').'-'.($use_tax?'1':'0').'-'.(int)$decimals;
        $specific_price = SpecificPrice::getSpecificPrice(
            (int)$id_product,
            $id_shop,
            $id_currency,
            $id_country,
            $id_group,
            $quantity,
            $id_product_attribute,
            $id_customer,
            $id_cart,
            $real_quantity
        );
        $configs_without_taxes = array();
        $configs_with_taxes = array();
        $configs_with_discounts = array();
        include_once(_PS_MODULE_DIR_.'groupinc/classes/GroupincConfiguration.php');
        $groupinc = new GroupincConfiguration();

        $cache_id_2 = $id_product.'-'.$id_shop;
        if (!isset(self::$_pricesLevel2[$cache_id_2])) {
            $sql = new DbQuery();
            $sql->select('product_shop.`price`, product_shop.`wholesale_price`, product_shop.`ecotax`');
            $sql->from('product', 'p');
            $sql->innerJoin('product_shop', 'product_shop', '(product_shop.id_product=p.id_product AND product_shop.id_shop = '.(int)$id_shop.')');
            $sql->where('p.`id_product` = '.(int)$id_product);
            if (Combination::isFeatureActive()){
                $sql->select('product_attribute_shop.id_product_attribute, product_attribute_shop.`price` AS attribute_price, product_attribute_shop.default_on');
                $sql->leftJoin('product_attribute', 'pa', 'pa.`id_product` = p.`id_product`');
                $sql->leftJoin('product_attribute_shop', 'product_attribute_shop', '(product_attribute_shop.id_product_attribute = pa.id_product_attribute AND product_attribute_shop.id_shop = '.(int)$id_shop.')');
            } else {
                $sql->select('0 as id_product_attribute');
            }
            $res = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);
            if (is_array($res) && count($res)) {
                foreach ($res as $row) {
                    $array_tmp = array(
                        'price' => $row['price'],
                        'ecotax' => $row['ecotax'],
                        'wholesale_price' => $row['wholesale_price'],
                        'attribute_price' => (isset($row['attribute_price']) ? $row['attribute_price'] : null)
                    );
                    self::$_pricesLevel2[$cache_id_2][(int)$row['id_product_attribute']] = $array_tmp;
                    if (isset($row['default_on']) && $row['default_on'] == 1) {
                        self::$_pricesLevel2[$cache_id_2][0] = $array_tmp;
                    }
                }
            }
        }
        if (!isset(self::$_pricesLevel2[$cache_id_2][(int)$id_product_attribute])) {
            return;
        }
        $result = self::$_pricesLevel2[$cache_id_2][(int)$id_product_attribute];
        $price = (float)$result['price'];
        $wholesale_price_without_taxes = (float)$result['wholesale_price'];
        $address->id_country = $id_country;
        $address->id_state = $id_state;
        $address->postcode = $zipcode;
        $tax_manager = TaxManagerFactory::getManager($address, Product::getIdTaxRulesGroupByIdProduct((int)$id_product, $context));
        $product_tax_calculator = $tax_manager->getTaxCalculator();
        $retail_price_without_taxes = $price;
        $attribute_price = Tools::convertPrice($result['attribute_price'] !== null ? (float)$result['attribute_price'] : 0, $id_currency);
        $retail_price_without_taxes += $attribute_price;
        $wholesale_price_without_taxes += $attribute_price;
        $retail_price_with_taxes = $product_tax_calculator->addTaxes($retail_price_without_taxes);
        $wholesale_price_with_taxes = $product_tax_calculator->addTaxes($wholesale_price_without_taxes);

        if (!in_array($context->controller->controller_type, array('admin'))) {
            $taxes = true;
            $configs_with_discounts = $groupinc->getGIConfigurations($id_shop, $id_product, $id_customer, $id_country, $id_state, $id_currency, $context->language->id, $taxes, true, $id_product_attribute);
        }
        if (isset($configs_with_discounts) and is_array($configs_with_discounts) and count($configs_with_discounts) > 0) {
            //$specific_price = $groupinc->getGroupincReduction($configs_with_discounts, $id_product, $specific_price);
            $specific_price = $groupinc->getGroupincReduction($configs_with_discounts, $id_product, $specific_price, $retail_price_with_taxes, $retail_price_without_taxes, $wholesale_price_with_taxes, $wholesale_price_without_taxes);
        } else {

            if (isset(self::$_prices[$cache_id])) {
                if (isset($specific_price['price']) && $specific_price['price'] > 0) {
                    $specific_price['price'] = self::$_prices[$cache_id];
                }
                return self::$_prices[$cache_id];
            }
        }
        self::$_pricesLevel2 = array();
        if (in_array($context->controller->controller_type, array('admin'))) {
            $configs_with_taxes = $groupinc->getAdminGIconfigurations($id_shop, $id_product);
        } else {
            $taxes = false;
            $configs_without_taxes = $groupinc->getGIConfigurations($id_shop, $id_product, $id_customer, $id_country, $id_state, $id_currency, $context->language->id, $taxes, false, $id_product_attribute);
            $taxes = true;
            $configs_with_taxes = $groupinc->getGIConfigurations($id_shop, $id_product, $id_customer, $id_country, $id_state, $id_currency, $context->language->id, $taxes, false, $id_product_attribute);
        }
        if (!$configs_with_taxes && !$configs_without_taxes && !$configs_with_discounts) {
            return parent::priceCalculation($id_shop, $id_product, $id_product_attribute, $id_country, $id_state, $zipcode, $id_currency,
                $id_group, $quantity, $use_tax, $decimals, $only_reduc, $use_reduc, $with_ecotax, $specific_price, $use_group_reduction,
                $id_customer, $use_customer_price, $id_cart, $real_quantity);
        }

        if (is_array($result) && (!$specific_price || !$specific_price['id_product_attribute'] || $specific_price['price'] < 0)) {
            $attribute_price = Tools::convertPrice($result['attribute_price'] !== null ? (float)$result['attribute_price'] : 0, $id_currency);
            if ($id_product_attribute !== false) {
                $price += $attribute_price;
            }
        }
        if ($use_group_reduction) {
            $reduction_from_category = GroupReduction::getValueForProduct($id_product, $id_group);
            if ($reduction_from_category !== false) {
                $group_reduction = $price * (float)$reduction_from_category;
            } else { // apply group reduction if there is no group reduction for this category
                $group_reduction = (($reduc = Group::getReductionByIdGroup($id_group)) != 0) ? ($price * $reduc / 100) : 0;
            }
        }

        $use_group_reduction_override = true;
        if ((isset($configs_without_taxes) and is_array($configs_without_taxes) and count($configs_without_taxes) > 0) || (isset($configs_with_taxes) and is_array($configs_with_taxes) and count($configs_with_taxes))) {
            if (isset($configs_without_taxes) and is_array($configs_without_taxes) and count($configs_without_taxes) > 0) {
                foreach ($configs_without_taxes as $giconfig) {
                    if (!empty($specific_price) || $group_reduction) {
                        if (!$giconfig['skip_discounts']) {
                            $id_gi_config = $giconfig['id_groupinc_configuration'];
                            $price = $groupinc->getPriceModified($id_gi_config, $retail_price_with_taxes, $retail_price_without_taxes, $wholesale_price_with_taxes, $wholesale_price_without_taxes);
                            $retail_price_without_taxes = $price;
                            $wholesale_price_without_taxes = $price;
                        }
                    } else {
                        $id_gi_config = $giconfig['id_groupinc_configuration'];
                        $price = $groupinc->getPriceModified($id_gi_config, $retail_price_with_taxes, $retail_price_without_taxes, $wholesale_price_with_taxes, $wholesale_price_without_taxes);
                        $retail_price_without_taxes = $price;
                        $wholesale_price_without_taxes = $price;
                    }
                    if ($giconfig['override_discounts']) {
                        $specific_price = array();
                        $use_group_reduction_override = false;
                    }
                }
                if ($use_tax) {
                    $price = $product_tax_calculator->addTaxes($price);
                }
            }
            if (isset($configs_with_taxes) and is_array($configs_with_taxes) and count($configs_with_taxes) > 0) {
                foreach ($configs_with_taxes as $giconfig) {
                    if (!empty($specific_price) || $group_reduction) {
                        if (!$giconfig['skip_discounts']) {
                            $id_gi_config = $giconfig['id_groupinc_configuration'];
                            $price = $groupinc->getPriceModified($id_gi_config, $retail_price_with_taxes, $retail_price_without_taxes, $wholesale_price_with_taxes, $wholesale_price_without_taxes);
                            $retail_price_with_taxes = $price;
                            $wholesale_price_with_taxes = $price;
                        }
                    } else {
                        $id_gi_config = $giconfig['id_groupinc_configuration'];
                        $price = $groupinc->getPriceModified($id_gi_config, $retail_price_with_taxes, $retail_price_without_taxes, $wholesale_price_with_taxes, $wholesale_price_without_taxes);
                        $retail_price_with_taxes = $price;
                        $wholesale_price_with_taxes = $price;
                    }
                    if ($giconfig['override_discounts']) {
                        $specific_price = array();
                        $use_group_reduction_override = false;
                    }
                }
                if (!$use_tax) {
                    $price = $product_tax_calculator->removeTaxes($price);
                }
            }
        } else {
            if ($use_tax) {
                $price = $product_tax_calculator->addTaxes($price);
            }
        }


        if (($result['ecotax'] || isset($result['attribute_ecotax'])) && $with_ecotax) {
            $ecotax = $result['ecotax'];
            if (isset($result['attribute_ecotax']) && $result['attribute_ecotax'] > 0) {
                $ecotax = $result['attribute_ecotax'];
            }
            if ($id_currency) {
                $ecotax = Tools::convertPrice($ecotax, $id_currency);
            }
            if ($use_tax) {
                $tax_manager = TaxManagerFactory::getManager(
                    $address,
                    (int)Configuration::get('PS_ECOTAX_TAX_RULES_GROUP_ID')
                );
                $ecotax_tax_calculator = $tax_manager->getTaxCalculator();
                $price += $ecotax_tax_calculator->addTaxes($ecotax);
                $wholesale_price_with_taxes += $ecotax_tax_calculator->addTaxes($ecotax);
            } else {
                $price += $ecotax;
                $wholesale_price_with_taxes += $ecotax;
            }
        }
        $apply_taxes_after = false;
        $price_to_apply = -1;
        if (isset($configs_with_discounts) and is_array($configs_with_discounts) and count($configs_with_discounts) > 0) {
            foreach ($configs_with_discounts as $giconfig) {
                if ($giconfig['price_calculation'] == 0) {
                    $price = $wholesale_price_without_taxes;
                }
                if ($giconfig['price_calculation'] == 1) {
                    $price = $retail_price_without_taxes;
                }
                if ($giconfig['price_calculation'] == 2) {
                    $price = $wholesale_price_with_taxes;
                }
                if ($giconfig['price_calculation'] == 3) {
                    $price = $retail_price_with_taxes;
                }
                if ($giconfig['price_application'] == 0) {
                    $price_to_apply = $wholesale_price_without_taxes;
                    $apply_taxes_after = true;
                }
                if ($giconfig['price_application'] == 1) {
                    $price_to_apply = $retail_price_without_taxes;
                    $apply_taxes_after = true;
                }
                if ($giconfig['price_application'] == 2) {
                    $price_to_apply = $wholesale_price_with_taxes;
                }
                if ($giconfig['price_application'] == 3) {
                    $price_to_apply = $retail_price_with_taxes;
                }
                break;
            }
        }
        if (!$specific_price || !($specific_price['price'] >= 0 && $specific_price['id_currency'])) {
            $price = Tools::convertPrice($price, $id_currency);
            if (isset($specific_price['price'])) {
                $specific_price['price'] = $price_to_apply;
            }
        }
        $specific_price_reduction = 0;
        if (($only_reduc || $use_reduc) && $specific_price) {
            if ($specific_price['reduction_type'] == 'amount') {
                $reduction_amount = $specific_price['reduction'];
                if (!$specific_price['id_currency']) {
                    $reduction_amount = Tools::convertPrice($reduction_amount, $id_currency);
                }
                $specific_price_reduction = !$use_tax ? $product_tax_calculator->removeTaxes($reduction_amount) : $reduction_amount;
            } else {
                $specific_price_reduction = $price * $specific_price['reduction'];
            }
        }
        if ($price_to_apply > -1) {
            $price_to_apply -= $specific_price_reduction;
            $price = $price_to_apply;
        } else{
            $price -= $specific_price_reduction;
        }
        $override_discounts = false;
        if (isset($configs_with_discounts) and is_array($configs_with_discounts) and count($configs_with_discounts) > 0) {
            if ($configs_with_discounts[0]['override_discounts'] == 1) {
                $override_discounts = true;
            }
            if ($use_tax and $apply_taxes_after) {
                $price = $product_tax_calculator->addTaxes($price);
            }
        }
        if ($use_group_reduction && $use_group_reduction_override) {
            $reduction_from_category = GroupReduction::getValueForProduct($id_product, $id_group);
            if ($reduction_from_category !== false) {
                $group_reduction = $price * (float)$reduction_from_category;
            } else { // apply group reduction if there is no group reduction for this category
                $group_reduction = (($reduc = Group::getReductionByIdGroup($id_group)) != 0) ? ($price * $reduc / 100) : 0;
            }
            $price -= $group_reduction;
        }
        if ($only_reduc) {
            return Tools::ps_round($specific_price_reduction, $decimals);
        }
        $price = Tools::ps_round($price, $decimals);
        if ($price < 0) {
            $price = 0;
        }
        self::$_prices[$cache_id] = $price;
        return self::$_prices[$cache_id];
    }
}